## Doubly-Linked Lists

Doubly-Linked Lists — linked lists that can be iterated over in both directions

## Functions

GList * | g_list_append ()
GList * | g_list_prepend ()
GList * | g_list_insert ()
GList * | g_list_insert_before ()
GList * | g_list_insert_sorted ()
GList * | g_list_remove ()
GList * | g_list_remove_link ()
GList * | g_list_delete_link ()
GList * | g_list_remove_all ()
void | g_list_free ()
void | g_list_free_full ()
GList * | g_list_alloc ()
void | g_list_free_1 ()
guint | g_list_length ()
GList * | g_list_copy ()
GList * | g_list_copy_deep ()
GList * | g_list_reverse ()
GList * | g_list_sort ()
gint | (*GCompareFunc) ()
GList * | g_list_insert_sorted_with_data ()
GList * | g_list_sort_with_data ()
gint | (*GCompareDataFunc) ()
GList * | g_list_concat ()
void | g_list_foreach ()
void | (*GFunc) ()
GList * | g_list_first ()
GList * | g_list_last ()
#define | g_list_previous()
#define | g_list_next()
GList * | g_list_nth ()
gpointer | g_list_nth_data ()
GList * | g_list_nth_prev ()
GList * | g_list_find ()
GList * | g_list_find_custom ()
gint | g_list_position ()
gint | g_list_index ()

## Types and Values

struct | GList
#define | g_list_free1

## Includes

    #include <gmodule.h>

## Description

The GList structure and its associated functions provide a standard doubly-linked list data structure.

Each element in the list contains a piece of data, together with pointers which link to the previous and next elements in the list. Using these pointers it is possible to move through the list in both directions (unlike the singly-linked GSList, which only allows movement through the list in the forward direction).

The double linked list does not keep track of the number of items and does not keep track of both the start and end of the list. If you want fast access to both the start and the end of the list, and/or the number of items in the list, use a GQueue instead.

The data contained in each element can be either integer values, by using one of the Type Conversion Macros, or simply pointers to any type of data.

List elements are allocated from the slice allocator, which is more efficient than allocating elements individually.

Note that most of the GList functions expect to be passed a pointer to the first element in the list. The functions which insert elements return the new start of the list, which may have changed.

There is no function to create a GList. `NULL` is considered to be a valid, empty list so you simply set a GList* to `NULL` to initialize it.

To add elements, use `g_list_append()`, `g_list_prepend()`, `g_list_insert()` and `g_list_insert_sorted()`.

To visit all elements in the list, use a loop over the list:

    1
    2
    3
    4
    5

    GList *l;
    for (l = list; l != NULL; l = l->next)
      {
        // do something with l->data
      }

To call a function for each element in the list, use `g_list_foreach()`.

To loop over the list and modify it (e.g. remove a certain element) a while loop is more appropriate, for example:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11

    GList *l = list;
    while (l != NULL)
      {
        GList *next = l->next;
        if (should_be_removed (l))
          {
            // possibly free l->data
            list = g_list_delete_link (list, l);
          }
        l = next;
      }

To remove elements, use `g_list_remove()`.

To navigate in a list, use `g_list_first()`, `g_list_last()`, `g_list_next()`, `g_list_previous()`.

To find elements in the list use `g_list_nth()`, `g_list_nth_data()`, `g_list_find()` and `g_list_find_custom()`.

To find the index of an element use `g_list_position()` and `g_list_index()`.

To free the entire list, use `g_list_free()` or `g_list_free_full()`.

## Functions

### g_list_append ()

    GList *
    g_list_append (GList *list,
                   gpointer data);

Adds a new element on to the end of the list.

Note that the return value is the new start of the list, if `list` was empty; make sure you store the new value.

g_list_append() has to traverse the entire list to find the end, which is inefficient when adding multiple elements. A common idiom to avoid the inefficiency is to use `g_list_prepend()` and reverse the list with `g_list_reverse()` when all elements have been added.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10

    // Notice that these are initialized to the empty list.
    GList *string_list = NULL, *number_list = NULL;

    // This is a list of strings.
    string_list = g_list_append (string_list, "first");
    string_list = g_list_append (string_list, "second");

    // This is a list of integers.
    number_list = g_list_append (number_list, GINT_TO_POINTER (27));
    number_list = g_list_append (number_list, GINT_TO_POINTER (14));

#### Parameters

list | a pointer to a GList |
data | the data for the new element |

#### Returns

either `list` or the new start of the GList if `list` was `NULL`

### g_list_prepend ()

    GList *
    g_list_prepend (GList *list,
                    gpointer data);

Prepends a new element on to the start of the list.

Note that the return value is the new start of the list, which will have changed, so make sure you store the new value.

    1
    2
    3
    4
    5

    // Notice that it is initialized to the empty list.
    GList *list = NULL;

    list = g_list_prepend (list, "last");
    list = g_list_prepend (list, "first");

Do not use this function to prepend a new element to a different element than the start of the list. Use `g_list_insert_before()` instead.

#### Parameters

list | a pointer to a GList, this must point to the top of the list |
data | the data for the new element |

#### Returns

a pointer to the newly prepended element, which is the new start of the GList

### g_list_insert ()

    GList *
    g_list_insert (GList *list,
                   gpointer data,
                   gint position);

Inserts a new element into the list at the given position.

#### Parameters

list | a pointer to a GList, this must point to the top of the list |
data | the data for the new element |
position | the position to insert the element. If this is negative, or is larger than the number of elements in the list, the new element is added on to the end of the list. |

#### Returns

the (possibly changed) start of the GList

### g_list_insert_before ()

    GList *
    g_list_insert_before (GList *list,
                          GList *sibling,
                          gpointer data);

Inserts a new element into the list before the given position.

#### Parameters

list | a pointer to a GList, this must point to the top of the list |
sibling | the list element before which the new element is inserted or `NULL` to insert at the end of the list |
data | the data for the new element |

#### Returns

the (possibly changed) start of the GList

### g_list_insert_sorted ()

    GList *
    g_list_insert_sorted (GList *list,
                          gpointer data,
                          GCompareFunc func);

Inserts a new element into the list, using the given comparison function to determine its position.

If you are adding many new elements to a list, and the number of new elements is much larger than the length of the list, use `g_list_prepend()` to add the new items and sort the list afterwards with `g_list_sort()`.

#### Parameters

list | a pointer to a GList, this must point to the top of the already sorted list |
data | the data for the new element |
func | the function to compare elements in the list. It should return a number > 0 if the first parameter comes after the second parameter in the sort order. |

#### Returns

the (possibly changed) start of the GList

### g_list_remove ()

    GList *
    g_list_remove (GList *list,
                   gconstpointer data);

Removes an element from a GList. If two elements contain the same data, only the first is removed. If none of the elements contain the data, the GList is unchanged.

#### Parameters

list | a GList, this must point to the top of the list |
data | the data of the element to remove |

#### Returns

the (possibly changed) start of the GList

### g_list_remove_link ()

    GList *
    g_list_remove_link (GList *list,
                        GList *llink);

Removes an element from a GList, without freeing the element. The removed element's prev and next links are set to `NULL`, so that it becomes a self-contained list with one element.

This function is for example used to move an element in the list (see the example for `g_list_concat()`) or to remove an element in the list before freeing its data:

    1
    2
    3

    list = g_list_remove_link (list, llink);
    free_some_data_that_may_access_the_list_again (llink->data);
    g_list_free (llink);

#### Parameters

list | a GList, this must point to the top of the list |
llink | an element in the GList |

#### Returns

the (possibly changed) start of the GList

### g_list_delete_link ()

    GList *
    g_list_delete_link (GList *list,
                        GList *link_);

Removes the node link_ from the list and frees it. Compare this to `g_list_remove_link()` which removes the node without freeing it.

#### Parameters

list | a GList, this must point to the top of the list |
link_ | node to delete from `list` |

#### Returns

the (possibly changed) start of the GList

### g_list_remove_all ()

    GList *
    g_list_remove_all (GList *list,
                       gconstpointer data);

Removes all list nodes with data equal to `data` . Returns the new head of the list. Contrast with `g_list_remove()` which removes only the first node matching the given data.

#### Parameters

list | a GList, this must point to the top of the list |
data | data to remove |

#### Returns

the (possibly changed) start of the GList

### g_list_free ()

    void
    g_list_free (GList *list);

Frees all of the memory used by a GList. The freed elements are returned to the slice allocator.

If list elements contain dynamically-allocated memory, you should either use `g_list_free_full()` or free them manually first.

#### Parameters

list | a GList |

### g_list_free_full ()

    void
    g_list_free_full (GList *list,
                      GDestroyNotify free_func);

Convenience method, which frees all the memory used by a GList, and calls `free_func` on every element's data.

#### Parameters

list | a pointer to a GList |
free_func | the function to be called to free each element's data |

Since: 2.28

### g_list_alloc ()

    GList *
    g_list_alloc (void);

Allocates space for one GList element. It is called by `g_list_append()`, `g_list_prepend()`, `g_list_insert()` and `g_list_insert_sorted()` and so is rarely used on its own.

#### Returns

a pointer to the newly-allocated GList element

### g_list_free_1 ()

    void
    g_list_free_1 (GList *list);

Frees one GList element, but does not update links from the next and previous elements in the list, so you should not call this function on an element that is currently part of a list.

It is usually used after `g_list_remove_link()`.

#### Parameters

list | a GList element |

### g_list_length ()

    guint
    g_list_length (GList *list);

Gets the number of elements in a GList.

This function iterates over the whole list to count its elements. Use a GQueue instead of a GList if you regularly need the number of items. To check whether the list is non-empty, it is faster to check `list` against `NULL`.

#### Parameters

list | a GList, this must point to the top of the list |

#### Returns

the number of elements in the GList

### g_list_copy ()

    GList *
    g_list_copy (GList *list);

Copies a GList.

Note that this is a "shallow" copy. If the list elements consist of pointers to data, the pointers are copied but the actual data is not. See `g_list_copy_deep()` if you need to copy the data as well.

#### Parameters

list | a GList, this must point to the top of the list |

#### Returns

the start of the new list that holds the same data as `list`

### g_list_copy_deep ()

    GList *
    g_list_copy_deep (GList *list,
                      GCopyFunc func,
                      gpointer user_data);

Makes a full (deep) copy of a GList.

In contrast with `g_list_copy()`, this function uses `func` to make a copy of each list element, in addition to copying the list container itself.

`func` , as a GCopyFunc, takes two arguments, the data to be copied and a `user_data` pointer. It's safe to pass `NULL` as user_data, if the copy function takes only one argument.

For instance, if `list` holds a list of GObjects, you can do:

    1

    another_list = g_list_copy_deep (list, (GCopyFunc) g_object_ref, NULL);

And, to entirely free the new list, you could do:

    1

    g_list_free_full (another_list, g_object_unref);

#### Parameters

list | a GList, this must point to the top of the list |
func | a copy function used to copy every element in the list |
user_data | user data passed to the copy function `func` , or `NULL` |

#### Returns

the start of the new list that holds a full copy of `list` , use `g_list_free_full()` to free it

Since: 2.34

### g_list_reverse ()

    GList *
    g_list_reverse (GList *list);

Reverses a GList. It simply switches the next and prev pointers of each element.

#### Parameters

list | a GList, this must point to the top of the list |

#### Returns

the start of the reversed GList

### g_list_sort ()

    GList *
    g_list_sort (GList *list,
                 GCompareFunc compare_func);

Sorts a GList using the given comparison function. The algorithm used is a stable sort.

#### Parameters

list | a GList, this must point to the top of the list |
compare_func | the comparison function used to sort the GList. This function is passed the data from 2 elements of the GList and should return 0 if they are equal, a negative value if the first element comes before the second, or a positive value if the first element comes after the second. |

#### Returns

the (possibly changed) start of the GList

### GCompareFunc ()

    gint
    (*GCompareFunc) (gconstpointer a,
                     gconstpointer b);

Specifies the type of a comparison function used to compare two values. The function should return a negative integer if the first value comes before the second, 0 if they are equal, or a positive integer if the first value comes after the second.

#### Parameters

a | a value |
b | a value to compare with |

#### Returns

negative value if `a` < `b` ; zero if `a` = `b` ; positive value if `a` > `b`

### g_list_insert_sorted_with_data ()

    GList *
    g_list_insert_sorted_with_data (GList *list,
                                    gpointer data,
                                    GCompareDataFunc func,
                                    gpointer user_data);

Inserts a new element into the list, using the given comparison function to determine its position.

If you are adding many new elements to a list, and the number of new elements is much larger than the length of the list, use `g_list_prepend()` to add the new items and sort the list afterwards with `g_list_sort()`.

#### Parameters

list | a pointer to a GList, this must point to the top of the already sorted list |
data | the data for the new element |
func | the function to compare elements in the list. It should return a number > 0 if the first parameter comes after the second parameter in the sort order. |
user_data | user data to pass to comparison function |

#### Returns

the (possibly changed) start of the GList

Since: 2.10

### g_list_sort_with_data ()

    GList *
    g_list_sort_with_data (GList *list,
                           GCompareDataFunc compare_func,
                           gpointer user_data);

Like `g_list_sort()`, but the comparison function accepts a user data argument.

#### Parameters

list | a GList, this must point to the top of the list |
compare_func | comparison function |
user_data | user data to pass to comparison function |

#### Returns

the (possibly changed) start of the GList

### GCompareDataFunc ()

    gint
    (*GCompareDataFunc) (gconstpointer a,
                         gconstpointer b,
                         gpointer user_data);

Specifies the type of a comparison function used to compare two values. The function should return a negative integer if the first value comes before the second, 0 if they are equal, or a positive integer if the first value comes after the second.

#### Parameters

a | a value |
b | a value to compare with |
user_data | user data |

#### Returns

negative value if `a` < `b` ; zero if `a` = `b` ; positive value if `a` > `b`

### g_list_concat ()

    GList *
    g_list_concat (GList *list1,
                   GList *list2);

Adds the second GList onto the end of the first GList. Note that the elements of the second GList are not copied. They are used directly.

This function is for example used to move an element in the list. The following example moves an element to the top of the list:

    1
    2

    list = g_list_remove_link (list, llink);
    list = g_list_concat (llink, list);

#### Parameters

list1 | a GList, this must point to the top of the list |
list2 | the GList to add to the end of the first GList, this must point to the top of the list |

#### Returns

the start of the new GList, which equals `list1` if not `NULL`

### g_list_foreach ()

    void
    g_list_foreach (GList *list,
                    GFunc func,
                    gpointer user_data);

Calls a function for each element of a GList.

#### Parameters

list | a GList, this must point to the top of the list |
func | the function to call with each element's data |
user_data | user data to pass to the function |

### GFunc ()

    void
    (*GFunc) (gpointer data,
              gpointer user_data);

Specifies the type of functions passed to `g_list_foreach()` and `g_slist_foreach()`.

#### Parameters

data | the element's data |
user_data | user data passed to `g_list_foreach()` or `g_slist_foreach()` |

### g_list_first ()

    GList *
    g_list_first (GList *list);

Gets the first element in a GList.

#### Parameters

list | any GList element |

#### Returns

the first element in the GList, or `NULL` if the GList has no elements

### g_list_last ()

    GList *
    g_list_last (GList *list);

Gets the last element in a GList.

#### Parameters

list | any GList element |

#### Returns

the last element in the GList, or `NULL` if the GList has no elements

### g_list_previous()

    #define             g_list_previous(list)

A convenience macro to get the previous element in a GList. Note that it is considered perfectly acceptable to access `list->prev` directly.

#### Parameters

list | an element in a GList |

#### Returns

the previous element, or `NULL` if there are no previous elements

### g_list_next()

    #define             g_list_next(list)

A convenience macro to get the next element in a GList. Note that it is considered perfectly acceptable to access `list->next` directly.

#### Parameters

list | an element in a GList |

#### Returns

the next element, or `NULL` if there are no more elements

### g_list_nth ()

    GList *
    g_list_nth (GList *list,
                guint n);

Gets the element at the given position in a GList.

This iterates over the list until it reaches the `n` -th position. If you intend to iterate over every element, it is better to use a for-loop as described in the GList introduction.

#### Parameters

list | a GList, this must point to the top of the list |
n | the position of the element, counting from 0 |

#### Returns

the element, or `NULL` if the position is off the end of the GList

### g_list_nth_data ()

    gpointer
    g_list_nth_data (GList *list,
                     guint n);

Gets the data of the element at the given position.

This iterates over the list until it reaches the `n` -th position. If you intend to iterate over every element, it is better to use a for-loop as described in the GList introduction.

#### Parameters

list | a GList, this must point to the top of the list |
n | the position of the element |

#### Returns

the element's data, or `NULL` if the position is off the end of the GList

### g_list_nth_prev ()

    GList *
    g_list_nth_prev (GList *list,
                     guint n);

Gets the element `n` places before `list` .

#### Parameters

list | a GList |
n | the position of the element, counting from 0 |

#### Returns

the element, or `NULL` if the position is off the end of the GList

### g_list_find ()

    GList *
    g_list_find (GList *list,
                 gconstpointer data);

Finds the element in a GList which contains the given data.

#### Parameters

list | a GList, this must point to the top of the list |
data | the element data to find |

#### Returns

the found GList element, or `NULL` if it is not found

### g_list_find_custom ()

    GList *
    g_list_find_custom (GList *list,
                        gconstpointer data,
                        GCompareFunc func);

Finds an element in a GList, using a supplied function to find the desired element. It iterates over the list, calling the given function which should return 0 when the desired element is found. The function takes two gconstpointer arguments, the GList element's data as the first argument and the given user data.

#### Parameters

list | a GList, this must point to the top of the list |
data | user data passed to the function |
func | the function to call for each element. It should return 0 when the desired element is found |

#### Returns

the found GList element, or `NULL` if it is not found

### g_list_position ()

    gint
    g_list_position (GList *list,
                     GList *llink);

Gets the position of the given element in the GList (starting from 0).

#### Parameters

list | a GList, this must point to the top of the list |
llink | an element in the GList |

#### Returns

the position of the element in the GList, or -1 if the element is not found

### g_list_index ()

    gint
    g_list_index (GList *list,
                  gconstpointer data);

Gets the position of the element containing the given data (starting from 0).

#### Parameters

list | a GList, this must point to the top of the list |
data | the data to find |

#### Returns

the index of the element containing the data, or -1 if the data is not found

## Types and Values

### struct GList

    struct GList {
      gpointer data;
      GList *next;
      GList *prev;
    };

The GList struct is used for each element in a doubly-linked list.

#### Members

gpointer `data`; | holds the element's data, which can be a pointer to any kind of data, or any integer value using the Type Conversion Macros |
GList *`next`; | contains the link to the next element in the list |
GList *`prev`; | contains the link to the previous element in the list |

### g_list_free1

    #define             g_list_free1

Another name for `g_list_free_1()`.